program PMSlabel;  { print a pm/ps graphic on mailing labels }
{

  Copyright (c) 1986,87,88        Version 1.7        20 Dec 1988

  Clint Hastings - The Wizard of Ahhs - KC7XX
  4602 South 600 East
  Salt Lake City, Utah 84107

  Permission granted for personal use. See documentation for more details.

  Freely redistributable, not public domain.  All rights reserved.

  Printer commands are taken from  ".DEF" files.
  Optional label text lines are taken from ".LAB" files.

}
{$V-}      { to allow different size string passing }
(* {$R+}  *)    { enable range checking }

const MaxPicRecs = 64;   { per dynamically allocated memory block }
      MaxNames   = 256;  { 64 * 4 blocks max }

type  CPUreg = record  case boolean of
                 false: (ax,bx,cx,dx,bp,si,di,ds,es,flags : integer);
                 true:  (al,ah,bl,bh,cl,ch,dl,dh          : byte)
               end;

      PSpic = array[0..51,0..10] of byte;
      PMpic = record
                d1 : array[0..3] of byte; { dummy filler }
                p  : PSpic;
                d2 : byte
              END;
      PMpicsArray = array[0..MaxPicRecs] of PMpic;
      PSpicsArray = array[0..MaxPicRecs] of PSpic;
      PMpicsType = record case boolean of
            true  : (m : array[0..3] of ^PMpicsArray);
            false : (s : array[0..3] of ^PSpicsArray)
            END;

      CharSet = set of char;
      Format = (Caps, Norm, Auto);  { for GetString :
                                      Caps = all caps, don't need shift lock
                                      Norm = as entered
                                      Auto = first letter is automatic caps }
      String80 = string[80];
      String40 = string[40];
      String20 = string[20];
      String255 = string[255];
      Pname = array[1..16] of char;
      LabelLineType = array[0..17] of string40;
      LabLineType = array[1..9] of integer;

const PicWidth   = 88;           { # of graphic bytes to send }
      LeftMargin = 9;
      Esc        = #27;
      UpArrow    = #1;
      DownArrow  = #3;
      USER       = 1;    { for ABORT }
      ERROR      = 2;
      PROGRAMEND = 0;
      NEXT       = -1;
      hx = 5;
      hy = 23;
      NumSet   : CharSet = ['0'..'9'];  { for GetString, GetInteger }
      FnameSet : CharSet = [' '..'}'];  { Chars valid for filenames }
      DefaultLabLine : array[1..9] of LabLineType =
           (( 6,18,18,18,18,18,18,18,18),   { 18 is invalid }
            ( 3, 9,18,18,18,18,18,18,18),
            ( 2, 6,10,18,18,18,18,18,18),
            ( 2, 5, 8,11,18,18,18,18,18),
            ( 1, 4, 7,10,13,18,18,18,18),
            ( 1, 2, 3, 4, 5, 6,18,18,18),   { 6-9 for custom small stuff. }
            ( 7, 8, 9,10,11,12,13,18,18),   { No real defaults. }
            ( 1, 3, 5, 7, 9,11,13,15,18),   { These can be used }
            ( 0, 2, 4, 6, 8,10,12,14,16));  {  for testing. }
      FILEtf = 1;
      FILEpf = 2;
      FILEdf = 3;

var  reg : CPUreg;
     sameG : string[1];
     ch, TextColor, PicColor : char;
     PicMode, RAMmode, FileMode, PSmode, same, Inverse, debug,
         GotNames, MailingList, DirMode, OverRide, ColorMode,
         VideoReset, EnterText  : boolean;
     FilesOpen : set of 1..8;
     Wide : array[0..18] of integer;
     WideStr, WideOffStr : array[0..9] of string20;
     filename : string80;
     MaxPic, g, n, Graphic, NumLabels, Col, Row, x, ThisCol,
         NumNames, NumLabLines, NumDirNames, NumCols, PRtype,
         TextSpace, GrSpacing, numtextlines : integer;
     LabLine : LabLineType;
     names : array[0..MaxNames] of Pname;
     DirNames : array[1..70] of string40;
     InterLabelSpacing, Do4DotLineFeed, NameFile, GraphicsMode,
         FileModeName, ColorChange : string[30];
     PrinterDef, TestStr : string[20];
     LabelLine, TextLine : LabelLineType;
     ColLabelLine : array[1..4] of LabelLineType;
     DefaultGraphicDir, DefaultLabelDir : string40;
     OldVideoMode : byte;
     PMpics  : PMpicsType;
     df, tf  : text;
     nf, pf  : file;
     pic     : PSpic;
     ColPic  : array[1..4] of PSpic;

     TC      : char;  { holds last char used to terminate input }



(*  ConstStr returns a string length of N filled with character C *)
function ConstStr(C : Char; N : Integer) : String255;
var  S : string80;
begin
  if N < 0 then  N := 0;
  S[0] := Chr(N);
  FillChar(S[1],N,C);
  ConstStr := S
end;


procedure UpCaseStr(VAR s : string255);
var  i : integer;
begin
  for i := 1 to length(s) do  s[i] := UpCase(s[i])
end;


(* trims leading spaces from string (left side) *)
procedure TrimL(var s : string80);
begin
  while copy(s,1,1) = ' ' do delete(s,1,1)
end;

(* trims trailing spaces from string (right side) *)
procedure TrimR(var s : string80);
begin
  if length(s) > 0 then
      while copy(s,length(s),1) = ' ' do s[0] := pred(s[0])
end;

(* trims leading & trailing spaces from string *)
procedure Trim(var s : string80);
begin
  TrimL(s);
  TrimR(s)
 end;


function GetKB(var  scan, ascii : byte) : char;
begin
  reg.ax := 0;           { used to get alternate keys }
  intr($16,reg);
  ascii := lo(reg.ax);
  scan := hi(reg.ax);
  GetKB := char(ascii)
end;

function GetCh(OKset: CharSet): char;  { gets & echoes a char }  { getascii }
var  ch: char;                         { used by all input routines }
     scan, ascii : byte;
begin
  repeat
    ch := GetKB(scan, ascii);
    if ch = #0 then
      case scan of
        { 59..68 : ;      f1 to f10 }
        79 : ch := #10;  { end - same as ctrl-return }
        71 : ch := #4;   { home }
        72 : ch := UpArrow;   { up arrow }
        75 : ch := #2;   { left arrow }
        80 : ch := DownArrow;   { down arrow }
        77 : ch := #9    { right arrow - same as tab }
        END;
    if not(ch in OKset) then write(#7)
  until ch in OKset;

  if ch >= ' ' then  write(ch);      { eliminate these for no echo }
  if ch = #8 then  write(#8' '#8);
  TC := ch;
  GetCh := ch
end;

(* GetString
   Always starts from present cursor position
   OKset is the set of acceptable characters
   Accepts string passed if you just hit a termination char
   Zeroes field and starts over if you hit any other key
   BE SURE to initialize string s before you pass it to this routine
*)
procedure GetString(var s  : string80;
                   strlen  : integer;
                   OKset,
                   TermSet : CharSet;
                   sType   : Format );

var  ch : char;
     stemp: string80;
     i: integer;
     Upper : boolean;
begin
  ch:=' ';  stemp:='';  Upper := true;
  write(s,constStr('_',strlen-length(s)));
  write(constStr(^H,strlen));

  repeat
    if length(stemp)=0 then  ch:=getch(OKset + TermSet)    { 1st  char }
      else if length(stemp)=strlen then  ch:=getch([^H] + TermSet) { last char }
        else ch:=getch(OKset + [^H] + TermSet);            { middle chars }

    if not (ch in TermSet) AND (length(stemp)=0) then BEGIN  { blank unused default }
        write(constStr('_',strlen-1));
        write(constStr(^H ,strlen-1))
        END;

    if ch = ^H then  BEGIN
          delete(stemp,length(stemp),1);    { BackSpace }
          write('_',^H)
          END
      else if not(ch in TermSet) then
             BEGIN
               if (Upper and (sType = auto)) or (sType = Caps)
                   then ch := UpCase(ch);
               write(^H,ch);
               Upper := ch = ' ';
               stemp := stemp + ch
             END

  until (ch in TermSet);
        TC := ch;
  if length(stemp) > 0 then s:=stemp;
  write(constStr(^H,length(stemp)));
  write(s,ConstStr(' ',strlen-length(s)))
end;


procedure ClearHelp;
begin
  gotoxy(1,hy);
  write(ConstStr(' ',78));
  gotoxy(1,hy+1);
  write(ConstStr(' ',77))
end;


procedure ABORT(e : integer);
var  ch : char;
begin
  ClearHelp;
  gotoxy(hx,hy);
  if e = user then write('Aborting at user request. ')
    else if e = error then write('Aborting! ');
  {$I-}
  if FILEtf in FilesOpen then close(tf);
  if FILEdf in FilesOpen then close(df);
  if FILEpf in FilesOpen then close(pf);
  {$I+}
  if PicMode and VideoReset then BEGIN    { restore original video mode }
      reg.ah := 15;        { get current video mode }
      intr($10,reg);
      if OldVideoMode <> reg.al then BEGIN   { don't bother if same }
          gotoxy(hx,hy+1);
          write('Hit <RETURN> to exit...');
          readln(ch);
          reg.ah := 0;
          reg.al := OldVideoMode;
          intr($10,reg)
          END
      END;
  HALT
end;


(* Yes or No input routine - space or ^M accepts default value
   default value ( passed ) shows on screen *)
function YESNO(default: boolean): boolean;
var  ch: char;
begin
  if default then write('Y'+^H)
             else write('N'+^H);
  ch := getch(['y','n','Y','N',^M,' ',Esc]);
  if ch = Esc then ABORT(user);
  if (ch=^M) or (ch=' ') then  YESNO := default
                         else  YESNO := (ch='y') OR (ch='Y')
end;


(* GetInteger
   Input an integer between low and high boundaries.
   <Return> accepts the default shown.  *)
function GetInteger(low, high, default : integer;
                               TermSet : CharSet) : integer;
var  strg : string[20];
     len,i,temp : integer;
     IntSet : CharSet;
begin
  repeat
    IntSet := NumSet;
    str(high,strg);           { calculate longest possible input string }
    Trim(strg);
    len := length(strg);
    str(low,strg);
    Trim(strg);
    if len < length(strg) then len := length(strg);
    if low < 0 then IntSet := IntSet + ['-'];

    str(default,strg);
    trim(strg);
    while length(strg) < len do  insert('_',strg,1);
    GetString(Strg,len,IntSet,TermSet,Norm);    { go get it }
    Trim(strg);
    while copy(strg,1,1) = '_' do  delete(strg,1,1);
    val(STRG,temp,i);
    if i <> 0 then temp := 0;

    if (temp < Low) or (temp > High) then
        write(^G,constStr(^H,len));
  until (temp >= Low) and (temp <= High);
  GetInteger := temp;
  write(constStr(^H,len),temp:len)
end;

procedure ShowGraphic(n : integer);  { on the screen }
var  y, x, i : integer;
     screen1 : array[0..99,0..79] of byte ABSOLUTE $B800:0;
     screen2 : array[0..99,0..79] of byte ABSOLUTE $BA00:0;
begin
  for y := 0 to 51 do
    if odd(y) then move(pic[y,0], screen2[y div 2 + 42, 50], 11)
              else move(pic[y,0], screen1[y div 2 + 42, 50], 11);
  if GotNames then BEGIN
      gotoxy(53,19);
      write(Names[n])
      END
end;


procedure ReadInPics(var n : integer);
var  i, a : integer;
begin
   a := 0;
   n := 0;
   repeat
       New(PMpics.m[a]);
       BlockRead(pf, PMpics.m[a]^[0], MaxPicRecs, i);
       n := n + i;
       a := succ(a)
   until i < MaxPicRecs;
   close(pf);
end;

(* get graphic and stuff in variable Pic *)
procedure GetGraphic(n : integer);
var  TempPMpic : PMpic;
     x,y : integer;
begin
  if RAMmode then BEGIN
      if n = NEXT then BEGIN
          if Graphic < NumNames-1 then Graphic := succ(Graphic)
                                  else Graphic := 0;
          n := Graphic
          END;
      if PSmode then Pic := PMpics.s[n shr 6]^[n and $3F]
        else Pic := PMpics.m[n shr 6]^[n and $3F].p
      END
    else BEGIN
      if n > NEXT then  seek(pf,n)
        else BEGIN
          if Graphic < NumNames-1 then
              Graphic := succ(Graphic);
          n := Graphic
          END;
      if PSmode then BlockRead(pf,Pic,1)
        else BEGIN
          BlockRead(pf,TempPMpic,1);
          Pic := TempPMpic.p
          END
      END;
  if Inverse then
    for x := 0 to 51 do
      for y := 0 to 10 do
        Pic[x,y] := 255-Pic[x,y];

  if PicMode then ShowGraphic(n)
    else if GotNames then BEGIN
        gotoxy(45,11);
        writeln(Names[n])
        END
end;


procedure PrintGraphic;
type  MaskType = array[0..3] of byte;
const BitMask : array[0..7] of byte =   ($80,$40,$20,$10,8,4,2,1);
      PrintMaskArray : array[1..2] of MaskType = ((8,4,2,1),($10,$20,$40,$80));
var   (* TempY, PrintMask : MaskType; *)
      PrintMask0,PrintMask1,PrintMask2,PrintMask3 : byte;
      Temp0,Temp1,Temp2,Temp3 : byte;
      temp,b : byte;
      w, y, x, i, j, c : integer;
      n1, n2 : char;
begin
(*  PrintMask := PrintMaskArray[PRtype]; *)
  PrintMask0 := PrintMaskArray[PRtype,0];
  PrintMask1 := PrintMaskArray[PRtype,1];
  PrintMask2 := PrintMaskArray[PRtype,2];
  PrintMask3 := PrintMaskArray[PRtype,3];
  w := PicWidth * NumCols + grspacing * (NumCols - 1);
  n1 := chr(w mod 256);         { calculate number of dots per line }
  n2 := chr(w div 256);

  ColPic[ ThisCol ] := Pic;
  ColLabelLine[ ThisCol ] := LabelLine;
  ThisCol := succ(ThisCol);

  if ThisCol > NumCols then BEGIN
      ThisCol := 1;
      for y := 0 to numtextlines do BEGIN
        if y < 13 then BEGIN
          if ColorMode then write(lst,ColorChange,PicColor);
          write(lst,GraphicsMode,n1,n2);
          for c := 1 to NumCols do BEGIN
            for x := 0 to 10 do BEGIN          { PicWidth = 11*8 }
                Temp0 := ColPic[c,(y shl 2), x];
                Temp1 := ColPic[c,(y shl 2)+1, x];
                Temp2 := ColPic[c,(y shl 2)+2, x];
                Temp3 := ColPic[c,(y shl 2)+3, x];
(*                for i := 0 to 3 do          { get next line }
                    TempY[i] := ColPic[c,(y shl 2)+i, x];   *)
                for j := 0 to 7 do BEGIN
                    temp := 0;
(*                    for i := 0 to 3 do
                       if (TempY[i] AND BitMask[j]) <> 0 then
                           temp := temp OR PrintMask[i];  *)
                    if (Temp0 AND BitMask[j]) <> 0 then
                        temp := temp OR PrintMask0;
                    if (Temp1 AND BitMask[j]) <> 0 then
                        temp := temp OR PrintMask1;
                    if (Temp2 AND BitMask[j]) <> 0 then
                        temp := temp OR PrintMask2;
                    if (Temp3 AND BitMask[j]) <> 0 then
                        temp := temp OR PrintMask3;
                    write(lst,chr(temp))
                    END
                END;
            if c < NumCols then BEGIN
                for i := 1 to grspacing do
                    write(lst,#0)
                END
            END
          END;
        TestStr := ColLabelLine[1,y];
        for c := 2 to NumCols do
            TestStr := TestStr + ColLabelLine[c,y];
        if TestStr <> '' then BEGIN   { skip if they're all blank }
            if ColorMode then write(lst,ColorChange,TextColor);
            for c := 1 to NumCols do
                if ColLabelLine[c,y] <> '' then BEGIN
                    write(lst,#13,WideStr[0]);
                    write(lst,ConstStr(' ',LeftMargin+textspace*(c-1)));
                    if Wide[y] >= 0 then write(lst,WideStr[ Wide[y] ]);
                    write(lst,ColLabelLine[c,y]);
                    if Wide[y] >= 0 then write(lst,WideOffStr[ Wide[y] ])
                    END;
            write(lst,#13)
            END;
        write(lst, #13, Do4DotLineFeed)
        END;
      write(lst, InterLabelSpacing)    { can be a null string }
      END
end;


procedure InfoScreen;
begin
  gotoxy(3,1);
  writeln('Copyright (c) 1986,87,88 - Clint Hastings - Salt Lake City, Utah');
  gotoxy(5,3);
  write('***************  P');
  if OverRide then
      if PSmode then write('S')
                   else write('M')
  else write('M / PS');
  writeln('  LABEL  MAKER  ***************'#10#10)
end;


procedure Help(s : string80);
var  oldX, oldY : integer;
begin
  oldX := whereX;
  oldY := whereY;
  gotoxy(hx,hy);
  write(s);
  gotoxy(oldX,oldY)
end;


procedure Parse(VAR line     : string40;
                    match    : string40;
                VAR variable : string40);
var  p, error : integer;
     nstr : string[5];
begin
  if copy(line,1,length(match)) = match then BEGIN
      variable := '';
      delete(line,1,length(match));   { delete identifier }
      p := pos(';',line);
      if p > 0 then  delete(line,p,1+length(line)-p);  { delete comments, if any }
      trim(line);
      while length(line) > 0 do BEGIN
          p := pos(',',line);
          if p > 0 then BEGIN
              nstr := copy(line,1,p-1);
              delete(line,1,p)
              END
            else BEGIN
              nstr := copy(line,1,length(line));
              line := ''
              END;
          val(nstr, p, error);
          if error = 0 then  variable := variable + chr(p)
          END
      END
end;


procedure ParseInt(VAR line     : string40;
                       match    : string40;
                   VAR variable : integer);
var  p, error : integer;
begin
  if copy(line,1,length(match)) = match then BEGIN
      delete(line,1,length(match));   { delete identifier }
      p := pos(';',line);
      if p > 0 then  delete(line,p,1+length(line)-p);  { delete comments, if any }
      trim(line);
      val(line,p,error);
      if error = 0 then  variable := p
      END
end;


procedure StrToInt(VAR line     : string40;
                       skip     : integer;  { number of chars to skip }
                   VAR variable : integer;
                   VAR OK       : boolean);
var  n, p, error : integer;
begin
  delete(line,1,skip);   { delete identifier }
  p := pos(';',line);
  if p > 0 then  delete(line,p,1+length(line)-p);  { delete comments, if any }
  trim(line);
  val(line,n,error);
  OK := error = 0;
  if OK then  variable := n
end;


procedure GetDirectory(VAR FileName   : string40;  { borrowed from some downloaded code }
                       VAR FilesExist : boolean);  { original source unknown }

type  buffertype   = record                        { NESTED procedures follow }
                        reserved : array[1..21] of byte;
                        attribute: byte;
                        time, date, FileSizeLo, FileSizeHi : integer;
                        name : string[13]
                      END;

VAR  i, LocationCode, ErrorReturn, OldX,OldY : integer;
     FullPath, template : string40;
     ch : char;
     error : byte;
     buffer : buffertype;


procedure SetDTA(VAR buff);
BEGIN
  with reg do BEGIN
      AX := $1A00;
      DS := seg(buff);
      DX := ofs(buff);
      MSDOS(reg)
    END
END;

procedure FindNext(VAR filename  : string40;
                   VAR Nexterror : integer);
VAR  carryflag, ci, di : integer;
     N : byte;
BEGIN
  with reg do BEGIN
      buffer.name := '             ';
      ah := $4F;
      MSDOS(reg);
      filename := '';
      carryflag := 1 and Flags;
      if (al = 2) or (al = 18) then carryflag := 1;
      If carryflag = 1 then  Nexterror := al
        else with buffer do BEGIN
            Nexterror := 0;
            for N := 0 to 12 do FileName := FileName + name[N];
            Trim(FileName);
            if FileName[length(FileName)] = #0 then
                Filename[0] := pred(Filename[0]);
            FileName := FullPath + FileName
            END
      END
END;

Procedure FindFirst (VAR filename  : string40;
                     VAR errorcode : integer );
VAR  carryflag, ci, di : integer;
      mask, N : byte;
BEGIN
    SetDTA(buffer);
    filename[ Length(filename) + 1] := chr(0);
    buffer.name := '             ';
    With reg do BEGIN
        ah := $4E;
        CX := 32;  {attribute}
        DS := Seg(filename);
        DX := Ofs(filename) + 1;
        MsDos(reg);
        { If there was an error set the error code and don't do
          anything else. }

        carryflag := 1 and Flags;
        if (al = 2) or (al = 18) then carryflag := 1;
        If carryflag = 1 then  errorcode := al
          else with buffer do BEGIN
            errorcode := 0;
            filename := '';
            for N := 0 to 12 do FileName := FileName + name[N];
            Trim(FileName);
            if FileName[length(FileName)] = #0 then
                Filename[0] := pred(Filename[0]);
            FileName := FullPath + FileName
            END
        END  {with}
END;

procedure GetAllFiles(VAR template    : string40;
                      VAR ErrorReturn : integer);
VAR  OneChar, ch, EscChoice : char;
     error, margin : integer;
BEGIN
  buffer.name := '             ';
  FindFirst(template, error);
  ErrorReturn := error;
  if error = 0 then BEGIN
    NumDirNames := succ(NumDirNames);
    DirNames[NumDirNames] := copy(template,1,40);
    repeat
      buffer.name := '             ';
      findNext(template,error);
      if error = 0 then BEGIN
        NumDirNames := succ(NumDirNames);
        DirNames[NumDirNames] := copy(template,1,40)
        END
    until error <> 0;
    if (error in [18,19]) then ErrorReturn := 0
  END
END;

function lastPos(C: char; S : string40) : byte;
VAR  temp, holder : byte;
BEGIN
  temp := 0;
  while pos(C,S) <> 0 do BEGIN
      temp := temp + pos(C,S);
      delete(S,1,pos(C,S))
      END;
  lastPos := temp
END;

BEGIN                   { GetDirectory }
  template := filename;
  FullPath := template;
  if lastPos('\',FullPath) <> 0 then
      FullPath := copy(FullPath,1,lastPos('\',FullPath))
    else if pos(':',FullPath) <> 0 then FullPath := copy(FullPath,1,2)
                                   else FullPath := '';
  GetAllFiles(template,ErrorReturn);
  FilesExist := ErrorReturn <> 1;
END;

procedure ReturnFileName(VAR filename : string40; FileType : integer);
label  ESCAPE;
var  OldFilename : string40;
     dn, oldX,oldY, startX, startY : integer;
     FilesExist : boolean;
begin
  startX := whereX;
  startY := whereY;
      REPEAT
        OldFileName := FileName;
        gotoxy(startX,startY);
        GetString(FileName,40,FnameSet,[UpArrow,DownArrow,#13,Esc],Caps);
        if TC = Esc then
            if FileType = 2 then GOTO ESCAPE
                            else ABORT(user);
        if Filename[length(FileName)] in [':','\'] then
            TC := DownArrow;
        if (TC = UpArrow) or (TC = DownArrow) then BEGIN
            if (OldFileName <> FileName) or (NumDirNames = 0) then BEGIN
                NumDirNames := 0;
                if (pos('*',filename) = 0) then  { no wild cards }
                  if FileType = 1 then BEGIN
                    if OverRide then
                      if PSmode then FileName := FileName + '*.DAT'
                                   else FileName := FileName + '*.SHP'
                    else FileName := FileName + '*.DAT'
                    END
                  else if FileType = 2 then BEGIN
                    FileName := FileName + '*.LAB'
                    END;

                GetDirectory(Filename,FilesExist);
                if FileType = 1 then
                  if not OverRide then BEGIN { in Auto mode, also check for PM files }
                    FileName := copy(FileName,1,length(Filename)-3) + 'SHP';
                    GetDirectory(FileName,FilesExist)
                    END;
                if NumDirNames = 0 then BEGIN
                    OldX := whereX;
                    OldY := whereY;
                    GotoXY(1,24);
                    WriteLn('No files found.');
                    gotoxy(oldX,oldY)
                    END;
                dn := 1;
                Filename := DirNames[dn]
                END;
            if (TC = DownArrow) and (dn > 1) then BEGIN
                dn := pred(dn);
                FileName := DirNames[dn]
                END
              else if (TC = UpArrow) and (dn < NumDirNames) then BEGIN
                dn := succ(dn);
                FileName := Dirnames[dn]
                END
            END;
        if TC = Esc then
            if FileType = 2 then GOTO ESCAPE
                            else ABORT(user)
      UNTIL TC = #13;
ESCAPE: ;   { want to enter text manually - forget about file }
end;

procedure Setup;
var  line, filename2 : string40;
     i, j : integer;
     ch : char;
     OK, EndOfString : boolean;
begin
  ClrScr;
  TC := ' ';
  ThisCol := 1;
  TextSpace := 31;   { defaults }
  GrSpacing := 282;
  InterLabelSpacing := '';
  Do4DotLineFeed := #27'J'#12;    { 12/216" }
  assign(df, PrinterDef);      { read printer definition file }
  {$I-}  reset(df);  {$I+}
  if IOresult <> 0 then BEGIN
      gotoxy(10,10);
      writeln(#7,'Can''t find ', PrinterDef, ' file!');
      ABORT(error)
      END;
  readln(df, line);
  while copy(line,1,3) <> 'END' do BEGIN
       Parse(line,   'DO4LF=',  Do4DotLineFeed);
       Parse(line,   'LABSP=',  InterLabelSpacing);
       Parse(line,   'GRAPH=',  GraphicsMode);
       Parse(line,   'COLORCH=',ColorChange);
       ParseInt(line,'NTL=',    numtextlines);
       ParseInt(line,'PRTYPE=', PRtype);
       ParseInt(line,'TEXTSP=', TextSpace);
       ParseInt(line,'GRSPACE=',GrSpacing);
       for ch := '0' to '9' do BEGIN
           Parse(line, 'CPI'+ch+'=', WideStr[ ord(ch)-ord('0') ]);
           Parse(line, 'OFF'+ch+'=', WideOffStr[ ord(ch)-ord('0') ])
           END;
       readln(df,line)
       END;
  {$I-}  close(df); {$I+}
  if FileMode then BEGIN
      assign(df,FileModeName);
      {$I-} reset(df);  {$I+}
      if IOresult <> 0 then BEGIN
          writeln(#7#10'Couldn''t find ',FileModeName,' in the current directory.');
          writeln('Since FileMode is true, control info comes from this file.');
          writeln('Please consult documentation for more details.'#10);
          ABORT(error)
          END;
      FilesOpen := FilesOpen + [FILEdf];
      writeln(#10'   Reading from ',FileModeName,'...')
      END;

  NumLabels := 1;
  Graphic := 0;
  for i := 0 to 17 do
      LabelLine[i] := '';
  if PicMode then BEGIN
      reg.ah := 15;   { save old video mode }
      intr($10,reg);
      OldVideoMode := reg.al;
      reg.ah := 0;
      reg.al := 6;  { set graphics mode -> 6 is 640x200 B&W }
      intr($10,reg)
      END
    else ClrScr;

  InfoScreen;

  if not EnterText then BEGIN      { open file with names & addresses }
      NameFile := 'Default.LAB';
      gotoxy(5,7);
      write('Names file ? ');
      if FileMode then BEGIN
          readln(df,NameFile);
          if NameFile = '' then  NameFile := 'Default.LAB';
          write(NameFile)
          END
      else if DirMode then BEGIN
          Help('Enter a name and address file directory or filename. Press RETURN.');
          gotoxy(hx,hy+1);
          write('Press UP or DOWN ARROW to scroll, RETURN to select, ESC to input.');
          gotoxy(18,7);
          NameFile := DefaultLabelDir;
          NumDirNames := 0;
          ReturnFileName(NameFile,2)
          END
      else BEGIN
          Help('Enter a file name containing names and addresses. Press RETURN.');
          gotoxy(hx,hy+1);
          write('Or press ESC to enter name and address manually.');
          GetString(NameFile,40,FnameSet,[#13,Esc],Caps)
          END;
      ClearHelp;
      if TC = Esc then BEGIN  { wants to enter text manually }
          EnterText := true;
          gotoxy(1,7);
          write(ConstStr(' ',78))
          END
      END;

  if not EnterText then BEGIN
      assign(tf, NameFile);    { open name file }
      {$I-}  reset(tf);  {$I+}
      if IOresult <> 0 then BEGIN
          gotoxy(hx,hy);
          write(#7'Couldn''t find ',NameFile,'!');
          ABORT(error)
          END;
      FilesOpen := FilesOpen + [FILEtf];
      for i := 1 to NumLabLines do
          readln(tf, LabelLine[LabLine[i]])
      END;

  gotoxy(5,9);
  write('Graphic file ? ');
  if FileMode then BEGIN
      readln(df,FileName);
      UpCaseStr(FileName);
      write(FileName)
      END
  else if DirMode then BEGIN
      Help('Enter a file directory or filename, then press RETURN.');
      gotoxy(hx,hy+1);
      write('Press UP or DOWN ARROW to scroll through names, RETURN to select.');
      FileName := DefaultGraphicDir;
      NumDirNames := 0;
      gotoxy(20,9);
      ReturnFileName(FileName,1)
      END
  else BEGIN
      Help('Enter a graphic filename and press Return.');
      if PSmode then FileName := 'B:GRLIB1.DAT'
                   else FileName := 'B:SLIB.SHP';
      GetString(FileName,40,FnameSet,[#13,Esc],Caps);
      if TC = Esc then ABORT(user)
      END;

  ClearHelp;
  if not OverRide then   { auto-select type of graphic file }
      PSmode := ( copy(FileName,length(FileName)-2,3) = 'DAT' );

  if PSmode then BEGIN
      assign(pf,FileName);
      {$I-}  reset(pf, sizeof(PSpic))  {$I+}
      END
    else BEGIN
      assign(pf,FileName);
      {$I-}  reset(pf, sizeof(PMpic))  {$I+}
      END;
  if IOresult <> 0 then BEGIN
      gotoxy(hx,hy);
      write(#7'Couldn''t find file "',Filename,'".');
      gotoxy(hx,hy+1);
      write('Please consult documentation.');
      ABORT(error)
      END;
  FilesOpen := FilesOpen + [FILEpf];
  NumNames := MaxNames;
  if RAMmode then  ReadInPics(NumNames);

  GotNames := false;
  filename2 := copy(filename,1,length(filename)-3);
  if PSmode then filename2 := filename2 + 'NAM'
               else filename2 := filename2 + 'SDR';
  assign(nf,fileName2);
  {$I-}  reset(nf, sizeof(Pname));  {$I+}
  if IOresult <> 0 then BEGIN
      gotoxy(hx,hy);
      write(#7'Couldn''t find file "',filename,'".');
      gotoxy(hx,hy+1);
      write('Graphic names unavailable.')
      END
    else BEGIN
      GotNames := true;
      i := NumNames;
      BlockRead(nf, Names[0], i, NumNames);
      {$I-} close(nf); {$I+}

      for i := 0 to NumNames-1 do BEGIN  { get rid of garbage in strings }
        EndOfString := false;
        for j := 1 to 16 do
          if not(Names[i][j] in [' '..#126]) or EndOfString then BEGIN
            EndOfString := true;
            Names[i][j] := ' '
            END
        END
      END;

end;

procedure InputTextLines;
var  i : integer;
begin
  gotoxy(hx,hy);
  write('Enter name and address lines for label.');
  gotoxy(7,5);
  write('Enter ',NumLabLines, ' label text lines:');
  for i := 1 to NumLabLines do BEGIN
      gotoxy(37,4+i);
      GetString(LabelLine[LabLine[i]],40,FnameSet,[#13,ESC],Auto);
      if TC = Esc then ABORT(user);
      END;
  gotoxy(7,5);
  write(ConstStr(' ',30));
  ClearHelp
end;


procedure MainLoop;
var  n, m, oldX, oldY, TempNumCols, nMax : integer;
     MoreLabels : boolean;
begin
  TC := ' ';
  TempNumCols := 0;
  REPEAT
      if EnterText then  InputTextLines;
      gotoxy(5,11);
      write('Starting graphic number to print ? ');
      if FileMode then BEGIN
          readln(df,Graphic);
          write(graphic)
          END
        else BEGIN
            oldX := whereX;
            oldY := whereY;
            gotoxy(hx,hy);
            write('Enter a number between 0 and ', NumNames-1,'.');
            if DirMode then BEGIN
                gotoxy(hx,hy+1);
                write('Or press the UP or DOWN ARROW keys to scroll through ');
                if PicMode then write('graphics.')
                           else write('numbers.')
                END;
            gotoxy(oldX,oldY);
            GetGraphic(graphic);
            gotoxy(oldX,oldY);
          REPEAT
            Graphic := GetInteger(0,NumNames-1,Graphic,
                                  [#13,Esc,UpArrow,DownArrow]);
            if (TC = UpArrow) or (TC = DownArrow) then BEGIN
                if (TC = DownArrow) and (Graphic > 0) then
                    Graphic := pred(Graphic)
                  else if (TC = UpArrow) and (Graphic < NumNames-1) then
                    Graphic := succ(Graphic);
                GetGraphic(Graphic);
                gotoxy(oldX,oldY)
                END;
            if TC = Esc then ABORT(user);
          UNTIL TC = #13
          END;

      GetGraphic(Graphic);
      ClearHelp;

      gotoxy(5,13);
      write('Number of Labels to print ? ');
      if FileMode then BEGIN
          readln(df,NumLabels);
          write(NumLabels)
          END
      else BEGIN
          Help('Enter a number between 0 and 9999.');
          NumLabels := GetInteger(0,9999,NumLabels,[#13,Esc]);
          ClearHelp
          END;
      if TC = Esc then ABORT(user);

      gotoxy(5,15);
      same := false;
      if FileMode then BEGIN
          readln(df,sameG);
          if NumLabels > 1 then
              write('All the same graphic (y/n) ? ',sameG);
          same := UpCase(sameG) <> 'N'
          END
        else
          if NumLabels > 1 then BEGIN
              write('All the same graphic (y/n) ? ');
              Help('NO prints a different graphic on each label.');
              same := YesNo(false);
              ClearHelp
              END
            else write(ConstStr(' ',31));

      MailingList := false;
      gotoxy(5,17);
      if FileMode then BEGIN
          readln(df,sameG);
          if NumLabels > 1 then
              write('All the same name (y/n) ? ',sameG);
          MailingList := Upcase(sameG) = 'N'
          END
      else if not EnterText then
          if NumLabels > 1 then BEGIN
              write('All the same name (y/n) ? ');
              Help('NO gets a new name and address for each label.');
              MailingList := not YesNo(true);
              ClearHelp
              END
            else write(ConstStr(' ',27));
      ThisCol := 1;
      nMax := Graphic-1+NumLabels;
      for n := Graphic to nMax do BEGIN
          if MailingList then       { show names and addresses }
              for m := 1 to NumLabLines do BEGIN
                  gotoxy(37,4+m);
                  write(LabelLine[LabLine[m]],
                        ConstStr(' ',40-length(LabelLine[LabLine[m]])))
                  END;

          if n = nMax then      { take care of odd numbers of labels }
            if NumCols > 1 then BEGIN
                TempNumCols := NumCols;
                NumCols := NumLabels mod NumCols;
                if NumCols = 0 then BEGIN { # labels MOD # cols  =  0 }
                    NumCols := TempNumCols;
                    TempNumCols := 0
                    END
                END;
          PrintGraphic;

                     { if not all the same graphic,fetch the next one here }
          if (not same) and (n < nMax) then GetGraphic(NEXT);

          if MailingList then
              for m := 1 to NumLabLines do
                  readln(tf,LabelLine[LabLine[m]])
          END;

      if TempNumCols > 0 then BEGIN    { reset number of columns }
          NumCols := TempNumCols;
          TempNumCols := 0
          END;
      MoreLabels := false;
      gotoxy(5,20);
      write('Print more labels (y/n) ? ');
      if FileMode  then BEGIN
          readln(df,sameG);
          write(sameG);
          MoreLabels := Upcase(sameG) = 'Y'
          END
      else BEGIN
          Help('NO exits the program.');
          MoreLabels := YesNo(false);
          ClearHelp
          END;
      writeln

   UNTIL not MoreLabels
end;

procedure PrintHelp;
begin
  ClrScr;
  gotoxy(6,2);
  writeln('PM / PS Mailing Labels');
  gotoxy(6,5);
  writeln('Command Line Option   (Default)');
  writeln('     ~~~~~~~~~~~~~~~~~~~~~~   ~~~~~~~~~');
  writeln('     -Cn  number of Columns   (1)');
  writeln('     -DG  Default graphic dir (B:)');
  writeln('     -DL  Default label dir   (B:)');
  writeln('     -F   File mode           (Keyboard)');
  writeln('     -GCn Graphic Color       (Black)');
  writeln('     -I   Inverse video       (Normal)');
  writeln('     -Ln  Lines per label     (3)');
  writeln('     -ND  No Directory        (Dir Mode)');
  writeln('     -NP  No pictures         (Pictures)');
  writeln('     -NR  No RAM              (RAM Mode)');
  writeln('     -NV  No Video reset      (Reset)');
  writeln('     -PM  PM mode             (Automatic)');
  writeln('     -PS  PS mode             (Automatic)');
  writeln('     -PR  Printer def file    (Printer.def)');
  writeln('     -TCn Text Color          (Black)');
  writeln('     -Vnn Custom Vertical Text Spacing');
  writeln('     -Wnn Width of text');
  HALT
end;


procedure ParseOption(VAR c : string80);
var  OK : boolean;
     ch : char;
     i, n : integer;
begin
  if c = '?' then PrintHelp
  else if copy(c,1,2) = '-V' then BEGIN
      ch := copy(c,3,1);
      n := ord(ch) - ord('0');
      if (n >= 1) and (n <= 9) then BEGIN
          StrToInt(c,3,i,OK);
          if OK and (i >= 0) and (i <= 17) then  LabLine[n] := i
          END
      END;
  if c = '-PS' then BEGIN
      OverRide := true;
      PSmode := true
      END
  else if c = '-PM' then BEGIN
      OverRide := true;
      PSmode := false
      END
  else if copy(c,1,3) = '-PR' then  PrinterDef := copy(c,4,99)
  else if copy(c,1,2) = '-F' then BEGIN
      FileModeName := copy(c,3,99);
      FileMode := true
      END;
  if c = '-NP' then PicMode := false
  else if c = '-ND' then DirMode := false
  else if c = '-NV' then VideoReset := false
  else if c = '-NR' then RAMmode := false
  else if c = '-I'  then Inverse := true
  else if c = '-DEBUG' then debug := true;
  if copy(c,1,2) = '-C' then BEGIN
      StrToInt(c,2,NumCols,OK);
      if (not OK) or (NumCols < 1) or (NumCols > 4) then  NumCols := 1
      END
  else if copy(c,1,3) = '-DL' then  DefaultLabelDir := copy(c,4,99)
  else if copy(c,1,3) = '-DG' then  DefaultGraphicDir := copy(c,4,99)
  else if copy(c,1,2) = '-W' then
      if length(c) = 4 then
          if (c[3] >= '1') and (c[3] <= '9') and
             (c[4] >= '0') and (c[4] <= '9') then BEGIN
              i := ord(c[3])-ord('0');
              Wide[LabLine[i]] := ord(c[4])-ord('0')
              END;
  if copy(c,1,3) = '-TC' then BEGIN
      ch := ' ';
      if length(c) >= 4 then ch := c[4];
      if (ch >= '0') and (ch <= '6') then BEGIN
          writeln('Textcolor ',ch);
          ColorMode := true;
          TextColor := ch
          END
      END
  else if copy(c,1,3) = '-GC' then BEGIN
      ch := ' ';
      if length(c) >= 4 then ch := c[4];
      if (ch >= '0') and (ch <= '6') then BEGIN
          writeln('PicColor ',ch);
          ColorMode := true;
          PicColor := ch
          END
      END
  else if copy(c,1,2) = '-L' then BEGIN
      StrToInt(c,2,i,OK);
      if OK and (i > 0) and (i <= 9) then BEGIN
          NumLabLines := i;
          LabLine := DefaultLabLine[i]
          END
      END
end;


procedure ParseCommandLine;
var  c : string80;
     p, i : integer;
begin
  for i := 1 to 5 do TextLine[i] := '';
  NumLabLines := 3;
  LabLine := DefaultLabLine[NumLabLines];
  for i := 0 to 18 do  Wide[i] := -1;
  for i := 0 to 9 do  BEGIN
      WideStr[i] := '';
      WideOffStr[i] := ''
      END;
  DefaultGraphicDir := 'B:';
  DefaultLabelDir := 'B:';
  PSmode := false;
  PrinterDef := 'Printer.DEF';
  FileMode := false;
  Inverse := false;
  DirMode := true;
  TextColor := '0';
  PicColor := '0';
  ColorMode := false;
  EnterText := false;
  VideoReset := true;
  ColorChange := '';
  FileModeName := '';
  PicMode := true;
  OverRide := false;
  NumCols := 1;
  RAMmode := true;
  FilesOpen := [];
  numtextlines := 17;
  PRtype := 1;

  assign(df,'CONFIG.PMS');
  {$I-}  reset(df);  {$I+}
  if IOresult = 0 then BEGIN         { Found configuration file }
      readln(df,c);
      trim(c);
      while copy(c,1,3) <> 'END' do BEGIN
          UpCaseStr(c);
          ParseOption(c);
          readln(df,c);
          trim(c)
          END;
      {$I-}  close(df)  {$I+}
      END;

  for p := 1 to ParamCount do BEGIN  { handle command line }
      c := ParamStr(p);
      UpCaseStr(c);
      ParseOption(c)
      END
end;


begin  { MAIN }
   ParseCommandLine;
   Setup;

   MainLoop;

   ABORT(PROGRAMEND)
end.

