program ConvertPMSnames;  { Convert PS,PM names to lower case }

{
  Copyright (c) 1986,87,88   Clint Hastings - Salt Lake City, Utah

  Shareware licensing fee paid for PMSlabel also covers all other
  utility programs included, such as this one.
}


{$U+}      { to let you ctrl-C out of the program }
{$V-}      { to allow different size string passing }


type  CharSet = set of char;

      Format = (Caps, Norm, Auto);  { for GetString :
                                       Caps = all caps, don't need shift lock
                                       Norm = as entered
                                       Auto = first letter is automatic caps }
      String80 = string[80];

      Pname = array[1..16] of char;


const  CR = #13;
       Esc = #27;
       NumSet   : CharSet = ['0'..'9'];
       PrintSet : CharSet = [' '..'}'];
       AlphaSet : CharSet = ['A'..'Z', 'a'..'z'];
       FnameSet : CharSet = [' '..#126];  { ?? only characters valid }
                                          { for filenames and paths }
var  ch : char;
     Nfilename : string80;
     g, n, Graphic, NumLabels, Col, Row, x, NumNames : integer;
     names : array[0..200] of Pname;

     nf  : file;

     TC : char;  { string termination character; i.e. - if you allow esc
                   or return, it tells you which one you pressed;
                   set by all input routines }


(*  ConstStr returns a string length of N filled with character C *)
function ConstStr(C : Char; N : Integer) : String80;
var  S : string80;
begin
  if N < 0 then  N := 0;
  S[0] := Chr(N);
  FillChar(S[1],N,C);
  ConstStr := S
end;

function GetCh(OKset: CharSet): char;  { gets & echoes a char }
var ch: char;                          { used by all input routines }
begin
  read(kbd,ch);
  while not(ch in OKset) do  BEGIN
      write(^G);
      read(kbd,ch)
      end;
  if ch >= ' ' then  write(ch);      { eliminate these for no echo }
  if ch = ^H then  write(^H,' ',^H);
  getch := ch
end;


(* GetString
   Always starts from present cursor position
   OKset is the set of acceptable characters
   Accepts string passed if you just hit a termination char
   Zeroes field and starts over if you hit any other key
   BE SURE to initialize string s before you pass it to this routine
*)
procedure GetString(var s  : string80;
                   strlen  : integer;
                   OKset,
                   TermSet : CharSet;
                   sType   : Format );

var  ch : char;
     stemp: string80;
     i: integer;
     Upper : boolean;
begin
  ch:=' ';  stemp:='';  Upper := true;
  write(s,constStr('_',strlen-length(s)));
  for i := 1 to strlen do write(^H);

  repeat
    if length(stemp)=0 then  ch:=getch(OKset + TermSet)    { 1st  char }
      else if length(stemp)=strlen then  ch:=getch([^H] + TermSet) { last char }
        else ch:=getch(OKset + [^H] + TermSet);            { middle chars }

    if not (ch in TermSet) AND (length(stemp)=0) then BEGIN  { blank unused default }
        for i := 1 to StrLen-1 do write('_');
        for i := 1 to StrLen-1 do write(^H)
        END;

    if ch = ^H then  BEGIN
          delete(stemp,length(stemp),1);    { BackSpace }
          write('_',^H)
          END
      else if not(ch in TermSet) then
             BEGIN
               if (Upper and (sType = auto)) or (sType = Caps)
                   then ch := UpCase(ch);
               write(^H,ch);
               Upper := ch = ' ';
               stemp := stemp + ch
             END

  until (ch in TermSet);
        TC := ch;
  if length(stemp) > 0 then s:=stemp;
  for i:=1 to length(stemp) do write(^H);
  write(s,'':strlen-length(s))
end;

procedure InfoScreen;
begin
  gotoxy(3,1);
  writeln('Copyright (c) 1986,87,88 - Clint Hastings - Salt Lake City, Utah');
  gotoxy(5,3);
  writeln('**********  PRINTSHOP / MASTER  FILE  CONVERTER  ****************'#10);
  gotoxy(5,5);
  writeln('PrintShop   name files end in ".NAM"');
  writeln('    PrintMaster name files end in ".SDR"'#10#10)
end;


function LowerCase(ch : char) : char;
begin
  if (ch >= 'A') and (ch <= 'Z') then
      ch := chr(ord(ch) + ord('a') - ord('A'));
  LowerCase := ch
end;


procedure ConvertThem;
var  i, j : integer;
     Upper : boolean;
begin
  writeln;
  write('    Converting...');
  for i := 0 to NumNames do BEGIN
      writeln('Converting ', Names[i]);
      Upper := true;
      for j := 1 to 16 do BEGIN
          if not( Names[i][j] in PrintSet ) then
              Names[i][j] := ' ';
          if Upper then Names[i][j] := UpCase(Names[i][j])
                   else Names[i][j] := LowerCase(Names[i][j]);
          Upper := (Names[i][j] = ' ');
          END
      END;
  writeln('           ', Names[i]);
end;


procedure WriteThem;
var  i : integer;
begin
  writeln;
  write('    Writing...');
  Nfilename := copy(NfileName,1,length(nfilename)-3) + 'NEW';
  assign(nf,NfileName);
  {$I-}  rewrite(nf,sizeof(Pname));  {$I+}
  if IOresult <> 0 then BEGIN
      writeln(#13#10#7#10'    Couldn''t open file "',Nfilename,'.NEW".');
      writeln(#13#10'    Aborting...');
      HALT
      END;

  BlockWrite(nf, Names[0], NumNames);
  close(nf);
  writeln
end;


procedure ReadThem;
var  i, j : integer;
     ch : char;
begin
  InfoScreen;

  write(#13#10'    Graphic file ? ');

  NfileName := 'B:GRLIB1';
  GetString(NfileName,40,FnameSet,[CR,Esc],Caps);
  if TC = Esc then HALT;

  writeln;
  write('    Reading...');
  assign(nf,NfileName);
  {$I-}  reset(nf, sizeof(Pname));  {$I+}
  if IOresult <> 0 then BEGIN
      writeln(#13#10#7#10'    Couldn''t find file "',Nfilename,'".');
      writeln(#13#10'    Aborting...');
      HALT
      END;

  NumNames := 256;
  BlockRead(nf, Names[0], NumNames, NumNames);
  writeln('Num Names = ', NumNames);
  close(nf)
end;



begin  { MAIN }
  TC := ' ';
  ClrScr;
  ReadThem;
  ConvertThem;
  WriteThem;
  writeln;
  writeln('    Finished.')
end.













